;SCREDT full screen editor for Model 4
;by Doug Thompson 01/31/88
;
;keys used:
;in normal mode, <F2> enters edit mode (large block cursor)
;in edit mode,   <ENTER> sends entire line cursor is on
;                <BREAK> aborts edit mode
;                <F2> toggles insert mode
;                <F3> deletes character under cursor
;                <F1> moves cursor to right of last non-blank
;                <SHIFT F1> clears to end of line
;                arrows move cursor around screen
;
;works in DOS and BASIC under TRSDOS 6.2
;
SVC	MACRO	#NUM
	LD	A,#NUM
	RST	28H
	ENDM
;
VDCTL	MACRO	#NUM
	LD	B,#NUM
	SVC	@VDCTL
	ENDM
;
@DSP	EQU	2
@EXIT	EQU	16H
@GTDCB	EQU	52H
@VDCTL	EQU	0FH
@FLAGS	EQU	65H
@ERROR	EQU	1AH
@HIGH$	EQU	64H
@GTMOD	EQU	53H
@DSPLY	EQU	0AH
@HEX16	EQU	63H
@CHNIO	EQU	14H
;
;------- install filter -------
;
	ORG	3000H
START	PUSH	DE
	LD	(MODDCB),DE
	SVC	@FLAGS
	BIT	3,(IY+2)
	JR	NZ,SKIP0
	LD	HL,MSG1
ABORT	SVC	@DSPLY
	LD	HL,-1
	SVC	@EXIT
SKIP0	LD	DE,'OD'
	SVC	@GTDCB
	LD	(DODCB1+2),HL
	LD	(DODCB2+2),HL
	LD	DE,MODNAM1
	SVC	@GTMOD
	JR	Z,SKIP1
	LD	HL,MSG2
	JR	ABORT
SKIP1	LD	HL,0007
	ADD	HL,DE
	LD	(U1+1),HL
	LD	(U2+1),HL
	LD	(U3+1),HL
	LD	(U4+1),HL
	LD	(U5+1),HL
	LD	(U6+1),HL
	LD	(SAME+1),HL
	LD	B,0
	LD	HL,0
	SVC	@HIGH$
	LD	(OLDHI),HL
	LD	BC,FINAL-SCREDT
	PUSH	BC
	XOR	A
	SBC	HL,BC
	LD	B,0
	SVC	@HIGH$
	INC	HL
	PUSH	HL
	LD	BC,SCREDT
	XOR	A
	SBC	HL,BC
	PUSH	HL
	POP	BC
	LD	IX,RELTBL
LOOPR	LD	L,(IX)
	LD	H,(IX+1)
	LD	A,H
	OR	L
	JR	Z,SKIPR
	PUSH	HL
	POP	IY
	LD	L,(IY)
	LD	H,(IY+1)
	ADD	HL,BC
	LD	(IY),L
	LD	(IY+1),H
	INC	IX
	INC	IX
	JR	LOOPR
SKIPR	LD	HL,SCREDT
	POP	DE
	POP	BC
	PUSH	DE
	LDIR
	POP	DE
	POP	HL
	LD	(HL),47H
	INC	HL
	LD	(HL),E
	INC	HL
	LD	(HL),D
	LD	HL,HEXBUF
	SVC	@HEX16
	LD	HL,MSG3
	SVC	@DSPLY
	LD	HL,0
	RET
;
MODNAM1	DEFM	'$DO'
	DEFB	0DH
MSG1	DEFM	'SCREDT must be installed with the SET command.'
	DEFB	0DH
MSG2	DEFM	'$DO module not found!  SCREDT not installed.'
	DEFB	0DH
MSG3	DEFM	'SCREDT filter installed at '
HEXBUF	DEFM	'---- hex.'
	DEFB	0DH
RELTBL	DEFW	RX1
	DEFW	RX2
	DEFW	RX3
	DEFW	RX4
	DEFW	RX5
	DEFW	RX6
	DEFW	RX7
	DEFW	RX8
	DEFW	RX9
	DEFW	RX10
	DEFW	RX11
	DEFW	0
;
;------- TRSDOS memory header -------
;
SCREDT	JR	HERE
OLDHI	DEFW	0
	DEFB	MODDCB-MODNAM2
MODNAM2	DEFM	'SCREDT'
MODDCB	DEFW	0
	DEFW	0
;
;------- data table -------
;
MODE	DEFB	0
CURS	DEFB	0
ROW	DEFB	0
COL	DEFB	0
;
;
;------- filter begins here -------
;
HERE	JR	C,FILTER
;
CHAIN	PUSH	IX
	LD	IX,(MODDCB)
RX1	EQU	$-2
	SVC	@CHNIO
	POP	IX
	RET
;
FILTER	LD	HL,MODE
RX2	EQU	$-2
	BIT	7,(HL)
	JR	NZ,ENTER
	PUSH	HL
	CALL	CHAIN
RX3	EQU	$-2
	POP	HL
	RET	NZ
	BIT	6,(HL)
	JR	NZ,EDIT
	CP	82H
	JR	Z,SKIP2
	CP	A
	RET
;
SKIP2	SET	6,(HL)
	LD	C,0BFH
	VDCTL	8
	LD	(CURS),A
RX4	EQU	$-2
	OR	1
	LD	A,0
	RET
;
;------- process enter mode -------
;
ENTER	LD	A,(COL)
RX5	EQU	$-2
COLCNT	CP	80
	JR	NC,DONE
	INC	A
	LD	(COL),A
RX6	EQU	$-2
	DEC	A
	LD	L,A
	LD	A,(ROW)
RX7	EQU	$-2
	LD	H,A
	VDCTL	1
	CP	A
	RET
DONE	RES	7,(HL)
DODCB1	LD	IY,0
	RES	3,(IY+0)
	LD	A,0DH
	CP	A
	RET
;
;------- check for keys in edit mode -------
;
EDIT	CP	80H
	JR	NZ,SKIP3
	RES	6,(HL)
	RES	5,(HL)
	PUSH	AF
RESTORE	LD	A,(CURS)
RX8	EQU	$-2
	LD	C,A
	VDCTL	8
	POP	AF
	CP	A
	RET
;
SKIP3	CP	0DH
	JR	NZ,SKIP4
	RES	6,(HL)
	RES	5,(HL)
	SET	7,(HL)
	VDCTL	4
	LD	A,H
	LD	(ROW),A
RX9	EQU	$-2
	XOR	A
	PUSH	AF
	LD	(COL),A
RX10	EQU	$-2
U1	LD	A,(0000)
	LD	C,A
	VDCTL	2
	LD	L,79
LOOP	VDCTL	1
	CP	' '
	JR	NZ,FOUND
	DEC	L
	JR	NZ,LOOP
FOUND	INC	L
	LD	A,L
	LD	(COLCNT+1),A
RX11	EQU	$-2
DODCB2	LD	IY,0
	SET	3,(IY+0)
	JR	RESTORE
;
SKIP4	CP	82H
	JR	NZ,SKIP5
	LD	A,(HL)
	XOR	20H
	LD	(HL),A
	BIT	5,A
	LD	C,0B3H
	JR	NZ,SKIP4A
	LD	C,0BFH
SKIP4A	VDCTL	8
	OR	1
	LD	A,0
	RET
;
SKIP5	CP	83H
	JR	NZ,SKIP6
	VDCTL	4
	LD	A,L
	CP	79
	JR	NZ,SKIP5A
	LD	A,' '
U2	LD	(0000),A
	JR	DONE1
SKIP5A	INC	L
	VDCTL	1
U3	LD	(0000),A
LOOP2	LD	A,L
	CP	79
	JR	NC,DONE2
	INC	L
	VDCTL	1
	DEC	L
	LD	C,A
	VDCTL	2
	INC	L
	JR	LOOP2
DONE2	LD	C,' '
	VDCTL	2
DONE1	OR	1
	LD	A,0
	RET
;
SKIP6	CP	81H
	JR	NZ,SKIP6A
	VDCTL	4
	LD	E,L
	LD	L,80
LOOP5	DEC	L
	LD	A,E
	CP	L
	JR	Z,SAME
	JR	NC,DONE1
	VDCTL	1
	CP	' '
	JR	Z,LOOP5
DONE4A	INC	L
DONE4	LD	A,L
	CP	80
	JR	C,SKIP6C
	DEC	L
SKIP6C	VDCTL	3
	JR	DONE1
SAME	LD	A,(0000)
	CP	' '
	JR	Z,DONE1
	JR	DONE4A
;
SKIP6A	CP	91H
	JR	NZ,SKIP6B
	LD	A,' '
U6	LD	(0000),A
	VDCTL	4
LOOP4	INC	L
	LD	A,L
	CP	80
	JR	NC,DONE1
	LD	C,' '
	VDCTL	2
	JR	LOOP4
;
SKIP6B	CP	08H
	JR	C,SKIP7
	CP	0CH
	JR	NC,SKIP7
	ADD	A,10H
DOIT	LD	C,A
	SVC	@DSP
	OR	1
	LD	A,0
	RET
;
SKIP7	BIT	5,(HL)
	JR	Z,DOIT
	LD	C,A
U4	LD	A,(0000)
	LD	D,A
	PUSH	DE
	PUSH	BC
	VDCTL	4
	LD	E,L
	LD	L,78
LOOP3	LD	A,E
	CP	L
	JR	NC,DONE3
	VDCTL	1
	INC	L
	LD	C,A
	VDCTL	2
	DEC	L
	DEC	L
	JR	LOOP3
DONE3	POP	BC
	SVC	@DSP
	POP	AF
U5	LD	(0000),A
	OR	1
	LD	A,0
	RET
;
FINAL	NOP
	END	START
